import { ModuleWithProviders } from '@angular/core';
import * as i0 from "@angular/core";
import * as i1 from "./components/footer/footer-template.directive";
import * as i2 from "./components/datatable.component";
import * as i3 from "./components/columns/column.directive";
import * as i4 from "./components/footer/pager.component";
import * as i5 from "./components/row-detail/row-detail.directive";
import * as i6 from "./components/body/body-group-header.directive";
import * as i7 from "./components/row-detail/row-detail-template.directive";
import * as i8 from "./components/columns/column-header.directive";
import * as i9 from "./components/columns/column-cell.directive";
import * as i10 from "./components/columns/column-ghost-cell.directive";
import * as i11 from "./components/columns/tree.directive";
import * as i12 from "./components/footer/footer.directive";
import * as i13 from "./components/body/body-group-header-template.directive";
import * as i14 from "./directives/disable-row.directive";
import * as i15 from "./components/body/body-row-def.component";
export declare class NgxDatatableModule {
    /**
     * Configure global configuration via INgxDatatableConfig
     * @param configuration
     */
    static forRoot(configuration: INgxDatatableConfig): ModuleWithProviders<NgxDatatableModule>;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxDatatableModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgxDatatableModule, never, [typeof i1.DataTableFooterTemplateDirective, typeof i2.DatatableComponent, typeof i3.DataTableColumnDirective, typeof i4.DataTablePagerComponent, typeof i5.DatatableRowDetailDirective, typeof i6.DatatableGroupHeaderDirective, typeof i7.DatatableRowDetailTemplateDirective, typeof i8.DataTableColumnHeaderDirective, typeof i9.DataTableColumnCellDirective, typeof i10.DataTableColumnGhostCellDirective, typeof i11.DataTableColumnCellTreeToggle, typeof i12.DatatableFooterDirective, typeof i13.DatatableGroupHeaderTemplateDirective, typeof i14.DisableRowDirective, typeof i15.DatatableRowDefComponent, typeof i15.DatatableRowDefDirective], [typeof i2.DatatableComponent, typeof i5.DatatableRowDetailDirective, typeof i6.DatatableGroupHeaderDirective, typeof i7.DatatableRowDetailTemplateDirective, typeof i3.DataTableColumnDirective, typeof i8.DataTableColumnHeaderDirective, typeof i9.DataTableColumnCellDirective, typeof i10.DataTableColumnGhostCellDirective, typeof i11.DataTableColumnCellTreeToggle, typeof i1.DataTableFooterTemplateDirective, typeof i12.DatatableFooterDirective, typeof i4.DataTablePagerComponent, typeof i13.DatatableGroupHeaderTemplateDirective, typeof i14.DisableRowDirective, typeof i15.DatatableRowDefComponent, typeof i15.DatatableRowDefDirective]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgxDatatableModule>;
}
/**
 * Interface definition for INgxDatatableConfig global configuration
 */
export interface INgxDatatableConfig {
    messages?: {
        emptyMessage: string;
        totalMessage: string;
        selectedMessage: string;
    };
    cssClasses?: {
        sortAscending: string;
        sortDescending: string;
        sortUnset: string;
        pagerLeftArrow: string;
        pagerRightArrow: string;
        pagerPrevious: string;
        pagerNext: string;
    };
    headerHeight?: number;
    footerHeight?: number;
    rowHeight?: number;
    defaultColumnWidth?: number;
}
